// Borland C++ Builder
// Copyright (c) 1995, 1998 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'smiupdate.pas' rev: 3.00

#ifndef smiupdateHPP
#define smiupdateHPP
#include <SMInStat.hpp>
#include <SMInBase.hpp>
#include <WinInet.hpp>
#include <Graphics.hpp>
#include <Controls.hpp>
#include <Windows.hpp>
#include <Classes.hpp>
#include <SysInit.hpp>
#include <System.hpp>

//-- user supplied -----------------------------------------------------------

namespace Smiupdate
{
//-- type declarations -------------------------------------------------------
enum TSMIService { isHTTP, isHTTPS, isFTP, isNetwork };

enum TSMIStatus { isInProgress, isFinished, isFailed, isSkipped, isNotFound };

enum TSMIAction { iaIdle, iaConnecting, iaConnected, iaDisconnecting, iaDisconnected, iaFileSearch, 
	iaFileFound, iaComparing, iaCompared, iaDownloading, iaDownloaded };

typedef void __fastcall (__closure *TSMIProgress)(System::TObject* Sender, int CurValue, int MaxValue
	, bool &Abort);

class DELPHICLASS TSMInetStatusDialog;
class PASCALIMPLEMENTATION TSMInetStatusDialog : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
private:
	bool FEnabled;
	Classes::THelpContext FHelpContext;
	System::AnsiString FTitle;
	System::AnsiString FDescription;
	Graphics::TPicture* FPicture;
	Graphics::TIcon* FIcon;
	Graphics::TPicture* __fastcall GetPicture(void);
	void __fastcall SetPicture(Graphics::TPicture* Value);
	Graphics::TIcon* __fastcall GetIcon(void);
	void __fastcall SetIcon(Graphics::TIcon* Value);
	
public:
	__fastcall virtual TSMInetStatusDialog(void);
	__fastcall virtual ~TSMInetStatusDialog(void);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	
__published:
	__property bool Enabled = {read=FEnabled, write=FEnabled, default=0};
	__property Classes::THelpContext HelpContext = {read=FHelpContext, write=FHelpContext, default=0};
	__property Graphics::TPicture* Picture = {read=GetPicture, write=SetPicture};
	__property Graphics::TIcon* Icon = {read=GetIcon, write=SetIcon};
	__property System::AnsiString Title = {read=FTitle, write=FTitle};
	__property System::AnsiString Description = {read=FDescription, write=FDescription};
};

class DELPHICLASS TSMCustomWebComponent;
class PASCALIMPLEMENTATION TSMCustomWebComponent : public Classes::TComponent 
{
	typedef Classes::TComponent inherited;
	
private:
	System::AnsiString FWEBAgent;
	Word FWEBPort;
	System::AnsiString FWEBHost;
	System::AnsiString FWEBUser;
	System::AnsiString FWEBPassword;
	TSMIService FService;
	TSMIStatus FStatus;
	TSMIAction FAction;
	Sminbase::TSMInetProxy* FProxy;
	TSMInetStatusDialog* FStatusDialog;
	bool FLoginPrompt;
	TSMIProgress FOnProgress;
	Classes::TNotifyEvent FOnActionChange;
	Classes::TNotifyEvent FOnStatusChange;
	Classes::TNotifyEvent FOnBeforeExecute;
	Classes::TNotifyEvent FOnAfterExecute;
	void __fastcall SetProxy(Sminbase::TSMInetProxy* Value);
	void __fastcall SetStatusDialog(TSMInetStatusDialog* Value);
	void __fastcall SetStatus(TSMIStatus Value);
	void __fastcall SetAction(TSMIAction Value);
	void __fastcall SetService(TSMIService Value);
	
protected:
	void *hInet;
	void *hURL;
	void *hFindFile;
	Sminstat::TfrmSMInetUpdate* dlgStatus;
	virtual void __fastcall InternalExecute(void) = 0;
	void __fastcall UpdateProgress(int BytesTotalRead, int RemoteFileSize, bool &Abort);
	void __fastcall ConnectToInet(void);
	void __fastcall DisconnectFromInet(void);
	bool __fastcall GetFileInfoFromInet(const System::AnsiString RemoteFileName, int &RemoteFileSize, _FILETIME 
		&RemoteFileCreated);
	bool __fastcall ReadFileFromInet(const System::AnsiString RemoteFileName, const System::AnsiString 
		LocalFileName, int RemoteFileSize);
	bool __fastcall ReadDirFromInet(const System::AnsiString Directory, const System::AnsiString WildCard
		, bool SubFolder, Classes::TStrings* lst);
	
public:
	__fastcall virtual TSMCustomWebComponent(Classes::TComponent* AOwner);
	__fastcall virtual ~TSMCustomWebComponent(void);
	virtual bool __fastcall Execute(void);
	__property TSMIAction Action = {read=FAction, write=SetAction, nodefault};
	__property TSMIStatus Status = {read=FStatus, write=SetStatus, nodefault};
	
__published:
	__property System::AnsiString Agent = {read=FWEBAgent, write=FWEBAgent};
	__property Word Port = {read=FWEBPort, write=FWEBPort, nodefault};
	__property TSMIService Service = {read=FService, write=SetService, default=0};
	__property System::AnsiString Host = {read=FWEBHost, write=FWEBHost};
	__property System::AnsiString User = {read=FWEBUser, write=FWEBUser};
	__property System::AnsiString Password = {read=FWEBPassword, write=FWEBPassword};
	__property Sminbase::TSMInetProxy* Proxy = {read=FProxy, write=SetProxy};
	__property TSMInetStatusDialog* StatusDialog = {read=FStatusDialog, write=SetStatusDialog};
	__property bool LoginPrompt = {read=FLoginPrompt, write=FLoginPrompt, default=1};
	__property TSMIProgress OnProgress = {read=FOnProgress, write=FOnProgress};
	__property Classes::TNotifyEvent OnBeforeExecute = {read=FOnBeforeExecute, write=FOnBeforeExecute};
		
	__property Classes::TNotifyEvent OnAfterExecute = {read=FOnAfterExecute, write=FOnAfterExecute};
	__property Classes::TNotifyEvent OnActionChange = {read=FOnActionChange, write=FOnActionChange};
	__property Classes::TNotifyEvent OnStatusChange = {read=FOnStatusChange, write=FOnStatusChange};
};

typedef void __fastcall (__closure *TSMIFileCompare)(System::TObject* Sender, bool &Equal);

class DELPHICLASS TSMCustomWebUpdater;
class PASCALIMPLEMENTATION TSMCustomWebUpdater : public Smiupdate::TSMCustomWebComponent 
{
	typedef Smiupdate::TSMCustomWebComponent inherited;
	
private:
	int FRemoteFileSize;
	_FILETIME FRemoteFileCreated;
	System::AnsiString FRemoteFileName;
	System::AnsiString FLocalFileName;
	TSMIFileCompare FOnFileCompare;
	
protected:
	virtual void __fastcall SetRemoteFileName(System::AnsiString Value);
	__property System::AnsiString LocalFileName = {read=FLocalFileName, write=FLocalFileName};
	
public:
	virtual void __fastcall InternalExecute(void);
	__property int RemoteFileSize = {read=FRemoteFileSize, nodefault};
	__property _FILETIME RemoteFileCreated = {read=FRemoteFileCreated};
	
__published:
	__property System::AnsiString RemoteFileName = {read=FRemoteFileName, write=SetRemoteFileName};
	__property TSMIFileCompare OnFileCompare = {read=FOnFileCompare, write=FOnFileCompare};
public:
	/* TSMCustomWebComponent.Create */ __fastcall virtual TSMCustomWebUpdater(Classes::TComponent* AOwner
		) : Smiupdate::TSMCustomWebComponent(AOwner) { }
	/* TSMCustomWebComponent.Destroy */ __fastcall virtual ~TSMCustomWebUpdater(void) { }
	
};

class DELPHICLASS TSMWebUpdater;
class PASCALIMPLEMENTATION TSMWebUpdater : public Smiupdate::TSMCustomWebUpdater 
{
	typedef Smiupdate::TSMCustomWebUpdater inherited;
	
__published:
	__property LocalFileName ;
public:
	/* TSMCustomWebComponent.Create */ __fastcall virtual TSMWebUpdater(Classes::TComponent* AOwner) : 
		Smiupdate::TSMCustomWebUpdater(AOwner) { }
	/* TSMCustomWebComponent.Destroy */ __fastcall virtual ~TSMWebUpdater(void) { }
	
};

//-- var, const, procedure ---------------------------------------------------

}	/* namespace Smiupdate */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Smiupdate;
#endif
//-- end unit ----------------------------------------------------------------
#endif	// smiupdate
